Index: /trunk/NEMO/OPA_SRC/BDY/bdytra.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 911)
+++ /trunk/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 911)
@@ -0,0 +1,87 @@
+MODULE bdytra
+   !!=================================================================================
+   !!                       ***  MODULE  bdytra  ***
+   !! Ocean tracers:   Flow Relaxation Scheme of tracers on each open boundary
+   !!=================================================================================
+#if defined key_bdy
+   !!---------------------------------------------------------------------------------
+   !!   'key_bdy'      :                         Unstructured Open Boundary Conditions
+   !!---------------------------------------------------------------------------------
+   !!   bdy_tra        : Relaxation of tracers on unstructured open boundaries
+   !!---------------------------------------------------------------------------------
+   !! * Modules used
+   USE oce             ! ocean dynamics and tracers variables
+   USE dom_oce         ! ocean space and time domain variables 
+   USE bdy_oce         ! ocean open boundary conditions
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+
+   IMPLICIT NONE
+   PRIVATE
+
+   !! * Accessibility
+   PUBLIC bdy_tra     ! routine called in tranxt.F90 
+
+   !! * Substitutions
+
+   !!---------------------------------------------------------------------------------
+   !!   OPA 9.0 , LODYC-IPSL  (2003)
+   !!---------------------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE bdy_tra( kt )
+      !!------------------------------------------------------------------------------
+      !!                 ***  SUBROUTINE bdy_tra  ***
+      !!                    
+      !! ** Purpose : Apply the Flow Relaxation Scheme for tracers in the  
+      !!              case of unstructured open boundaries.
+      !! 
+      !! Reference : Engedahl H., 1995: Use of the flow relaxation scheme in 
+      !!             a three-dimensional baroclinic ocean model with realistic
+      !!             topography. Tellus, 365-382.
+      !!  History :
+      !!   9.0  !  05-01 (J. Chanut, A. Sellar) Original
+      !!------------------------------------------------------------------------------
+      !! * Arguments
+      INTEGER, INTENT( in ) ::   kt
+
+      !! * Local declarations
+      REAL(wp) :: zwgt                       ! boundary weight
+      INTEGER ::   jb, jk, jgrd              ! dummy loop indices
+      INTEGER ::   ii, ij                    ! 2D addresses
+      !!------------------------------------------------------------------------------
+
+      jgrd=1 !: Everything is at T-points here
+ 
+      DO jb = 1, nblen(jgrd)
+        DO jk = 1, jpkm1
+          ii = nbi(jb,jgrd)
+          ij = nbj(jb,jgrd)
+          zwgt = nbw(jb,jgrd)
+
+          ! Temperature relaxation at the boundary   
+          ta(ii,ij,jk) = ( ta(ii,ij,jk)*(1.-zwgt)  +  tbdy(jb,jk)*zwgt ) &
+                                                          * tmask(ii,ij,jk)         
+
+          ! Salinity relaxation at the boundary   
+          sa(ii,ij,jk) = ( sa(ii,ij,jk)*(1.-zwgt)  +  sbdy(jb,jk)*zwgt ) &
+                                                          * tmask(ii,ij,jk)
+   
+        END DO
+      END DO 
+
+      CALL lbc_lnk( ta, 'T', 1. ) ! Boundary points should be updated
+      CALL lbc_lnk( sa, 'T', 1. ) !
+
+   END SUBROUTINE bdy_tra
+#else
+   !!---------------------------------------------------------------------------------
+   !!   Default option                                                    Empty module
+   !!---------------------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE bdy_tra      ! Empty routine
+   END SUBROUTINE bdy_tra
+#endif
+
+   !!=================================================================================
+END MODULE bdytra
Index: /trunk/NEMO/OPA_SRC/BDY/bdyvol.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/BDY/bdyvol.F90	(revision 911)
+++ /trunk/NEMO/OPA_SRC/BDY/bdyvol.F90	(revision 911)
@@ -0,0 +1,206 @@
+MODULE bdyvol
+   !!=================================================================================
+   !!                       ***  MODULE  bdyvol  ***
+   !! Ocean dynamic :  Volume constraint when unstructured boundary 
+   !!                  and Free surface are used
+   !!=================================================================================
+#if   defined key_bdy   &&   defined key_dynspg_flt
+   !!---------------------------------------------------------------------------------
+   !!   'key_bdy'               and              unstructured open boundary conditions
+   !!   'key_dynspg_flt'                                  constant volume free surface
+   !!---------------------------------------------------------------------------------
+   !! * Modules used
+   USE oce             ! ocean dynamics and tracers 
+   USE dom_oce         ! ocean space and time domain 
+   USE phycst          ! physical constants
+   USE bdy_oce         ! ocean open boundary conditions
+   USE lib_mpp         ! for mppsum
+   USE in_out_manager  ! I/O manager
+   USE sbc_oce         ! ocean surface boundary conditions
+
+   IMPLICIT NONE
+   PRIVATE
+
+   !! * Accessibility
+   PUBLIC bdy_vol        ! routine called by dynspg_flt.h90
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+   !!---------------------------------------------------------------------------------
+   !!   OPA 9.0 , LODYC-IPSL  (2003)
+   !!---------------------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE bdy_vol ( kt )
+      !!------------------------------------------------------------------------------
+      !!                      ***  ROUTINE bdyvol  ***
+      !!
+      !! ** Purpose : 
+      !!      This routine is called in dynspg_flt to control 
+      !!      the volume of the system. A correction velocity is calculated
+      !!      to correct the total transport through the unstructured OBC. 
+      !!      The total depth used is constant (H0) to be consistent with the 
+      !!      linear free surface coded in OPA 8.2
+      !!
+      !! ** Method :  
+      !!      The correction velocity (zubtpecor here) is defined calculating
+      !!      the total transport through all open boundaries (trans_bdy) minus
+      !!      the cumulate E-P flux (zCflxemp) divided by the total lateral 
+      !!      surface (bdysurftot) of the unstructured boundary. 
+      !!
+      !!      zubtpecor = [trans_bdy - zCflxemp ]*(1./bdysurftot)
+      !!
+      !!      with zCflxemp => sum of (Evaporation minus Precipitation)
+      !!                       over all the domain in m3/s at each time step.
+      !!
+      !!      zCflxemp < 0 when precipitation dominate
+      !!      zCflxemp > 0 when evaporation dominate
+      !!
+      !!      There are 2 options (user's desiderata): 
+      !!
+      !!         1/ The volume changes according to E-P, this is the default
+      !!            option. In this case the cumulate E-P flux are setting to
+      !!            zero (zCflxemp=0) to calculate the correction velocity. So
+      !!            it will only balance the flux through open boundaries.
+      !!            (set volbdy to 0 in tne namelist for this option)
+      !!
+      !!         2/ The volume is constant even with E-P flux. In this case
+      !!            the correction velocity must balance both the flux 
+      !!            through open boundaries and the ones through the free
+      !!            surface. 
+      !!            (set volbdy to 1 in tne namelist for this option)
+      !!
+      !! History :
+      !!   8.5  !  05-01 (J. Chanut, A. Sellar) Original code
+      !!        !  06-01 (J. Chanut) Bug correction
+      !!----------------------------------------------------------------------------
+      !! * Arguments
+      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
+
+      !! * Local declarations
+      INTEGER ::   ji,jj,jb, jgrd, jk
+      REAL(wp) ::   zubtpecor
+      REAL(wp) ::   zCflxemp
+      REAL(wp) ::   ztranst
+      !!-----------------------------------------------------------------------------
+
+      IF( kt == nit000 ) THEN 
+         IF(lwp) WRITE(numout,*)'        '
+         IF(lwp) WRITE(numout,*)'bdy_vol : Correction of velocities along unstructured OBC'
+         IF(lwp) WRITE(numout,*)'~~~~~~~'
+         IF(lwp) WRITE(numout,*)'        '
+      END IF 
+
+      ! 1. Calculate the cumulate surface Flux zCflxemp (m3/s) over all the domain.
+      ! ---------------------------------------------------------------------------
+ 
+      zCflxemp = 0.e0
+
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zCflxemp = zCflxemp + ( (emp(ji,jj)*bdytmask(ji,jj)*tmask_i(ji,jj) )/rauw) &
+                                  *e1v(ji,jj)*e2u(ji,jj)
+         END DO
+      END DO
+      IF( lk_mpp )   CALL mpp_sum( zCflxemp )   ! sum over the global domain
+
+      ! 2. Barotropic velocity through the unstructured open boundary
+      ! -------------------------------------------------------------
+
+      zubtpecor = 0.e0
+
+      jgrd = 2 ! cumulate u component contribution first 
+      DO jb = 1, nblenrim(jgrd)
+        DO jk = 1, jpkm1
+          zubtpecor = zubtpecor + flagu(jb) * ua (nbi(jb,jgrd), nbj(jb,jgrd), jk) &
+                                            * e2u(nbi(jb,jgrd), nbj(jb,jgrd)) &
+                                            * fse3u(nbi(jb,jgrd), nbj(jb,jgrd), jk)
+        END DO
+      END DO
+
+      jgrd = 3 ! then add v component contribution
+       DO jb = 1, nblenrim(jgrd)
+        DO jk = 1, jpkm1
+          zubtpecor = zubtpecor + flagv(jb) * va (nbi(jb,jgrd), nbj(jb,jgrd), jk) &
+                                            * e1v(nbi(jb,jgrd), nbj(jb,jgrd)) &
+                                            * fse3v(nbi(jb,jgrd), nbj(jb,jgrd), jk) 
+        END DO
+      END DO
+
+      IF( lk_mpp )   CALL mpp_sum( zubtpecor )   ! sum over the global domain
+
+
+      ! 3. The normal velocity correction
+      ! ---------------------------------
+
+      IF (volbdy==1) THEN
+        zubtpecor = (zubtpecor - zCflxemp)*(1./bdysurftot) 
+      ELSE
+        zubtpecor =  zubtpecor*(1./bdysurftot)
+      END IF
+
+      IF( lwp .AND. MOD( kt, nwrite ) == 0) THEN
+         IF(lwp) WRITE(numout,*)'        '
+         IF(lwp) WRITE(numout,*)'bdy_vol : time step :', kt
+         IF(lwp) WRITE(numout,*)'~~~~~~~ '
+         IF(lwp) WRITE(numout,*)'        '
+         IF(lwp) WRITE(numout,*)'          cumulate flux EMP :', zCflxemp,' (m3/s)'
+         IF(lwp) WRITE(numout,*)'          total lateral surface of OBC :',bdysurftot,'(m2)'
+         IF(lwp) WRITE(numout,*)'          correction velocity zubtpecor :',zubtpecor,'(m/s)'
+         IF(lwp) WRITE(numout,*)'        '
+      END IF 
+
+      ! 4. Correction of the total velocity on the unstructured 
+      !    boundary to respect the mass flux conservation
+      ! -------------------------------------------------------
+
+      ztranst = 0.e0
+
+      jgrd = 2 ! correct u component
+      DO jb = 1, nblenrim(jgrd)
+        DO jk = 1, jpkm1
+          ua(nbi(jb, jgrd), nbj(jb, jgrd), jk) = ua(nbi(jb, jgrd), nbj(jb, jgrd), jk) &
+                            -flagu(jb) * zubtpecor * umask(nbi(jb, jgrd), nbj(jb, jgrd), jk)
+          ztranst = ztranst + flagu(jb) * ua (nbi(jb,jgrd), nbj(jb,jgrd), jk) &
+                                        * e2u(nbi(jb,jgrd), nbj(jb,jgrd)) &
+                                        * fse3u(nbi(jb,jgrd), nbj(jb,jgrd), jk)
+        END DO
+      END DO
+
+      jgrd = 3 ! correct v component
+       DO jb = 1, nblenrim(jgrd)
+        DO jk = 1, jpkm1
+          va(nbi(jb, jgrd), nbj(jb, jgrd), jk) = va(nbi(jb, jgrd), nbj(jb, jgrd), jk) &
+                            -flagv(jb) * zubtpecor * vmask(nbi(jb, jgrd), nbj(jb, jgrd), jk)
+          ztranst = ztranst + flagv(jb) * va (nbi(jb,jgrd), nbj(jb,jgrd), jk) &
+                                        * e1v(nbi(jb,jgrd), nbj(jb,jgrd)) &
+                                        * fse3v(nbi(jb,jgrd), nbj(jb,jgrd), jk)
+        END DO
+      END DO
+      
+      IF( lk_mpp )   CALL mpp_sum( ztranst )   ! sum over the global domain
+ 
+      ! 5. Check the cumulate transport through unstructured OBC
+      !    once barotropic velocities corrected
+      ! --------------------------------------------------------
+
+      IF( lwp .AND. MOD( kt, nwrite ) == 0) THEN
+         IF(lwp) WRITE(numout,*)'        '
+         IF(lwp) WRITE(numout,*)'          Cumulate transport ztranst =', ztranst,'(m3/s)'
+         IF(lwp) WRITE(numout,*)'        '
+      END IF 
+
+   END SUBROUTINE bdy_vol
+
+#else
+   !!---------------------------------------------------------------------------------
+   !!  Default option :                                                   Empty module
+   !!---------------------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE bdy_vol        ! Empty routine
+   END SUBROUTINE bdy_vol
+#endif
+
+   !!=================================================================================
+END MODULE bdyvol
Index: /trunk/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 911)
@@ -5,4 +5,5 @@
    !!======================================================================
    !! History :   9.0  !  06-06  (B. Levier, L. Marie)  original code
+   !!              "   !  07-07  (D. Storkey) Bug fixes and code for BDY option.
    !!----------------------------------------------------------------------
 
@@ -24,4 +25,5 @@
    USE lib_mpp         ! distributed memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE bdy_oce         ! unstructured open boundary conditions
 
    IMPLICIT NONE
@@ -116,8 +118,15 @@
             zpk = mbathy(ji,jj) - 1
             DO jk = 1, zpk
+#if defined key_sigma_vvl
+               mut(ji,jj,jk) = 1./SUM( fsve3t(ji,jj,1:zpk) ) 
+               muu(ji,jj,jk) = 1./SUM( fsve3u(ji,jj,1:zpk) ) 
+               muv(ji,jj,jk) = 1./SUM( fsve3v(ji,jj,1:zpk) ) 
+               muf(ji,jj,jk) = 1./SUM( fsve3f(ji,jj,1:zpk) ) 
+#else
                mut(ji,jj,jk) = SUM( fsve3t(ji,jj,jk:zpk) ) / zmut(ji,jj)
                muu(ji,jj,jk) = SUM( fsve3u(ji,jj,jk:zpk) ) / zmuu(ji,jj)
                muv(ji,jj,jk) = SUM( fsve3v(ji,jj,jk:zpk) ) / zmuv(ji,jj)
                muf(ji,jj,jk) = SUM( fsve3f(ji,jj,jk:zpk) ) / zmuf(ji,jj)
+#endif
             END DO
          END DO
@@ -191,4 +200,9 @@
       END DO
 
+      IF( MINVAL(fse3t(:,:,:)) < 0.0 ) THEN
+         CALL ctl_stop('E R R O R : dom_vvl','Level thickness fse3t less than zero.')
+         nstop = nstop+1
+      ENDIF
+
       ! Local depth or Inverse of the local depth of the water column at u- and v-points
       ! ------------------------------
@@ -288,4 +302,12 @@
 #endif
 
+#if defined key_bdy || key_bdy_tides
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            zhdiv(ji,jj) = zhdiv(ji,jj)*bdytmask(ji,jj)
+         END DO
+      END DO
+#endif
+
       CALL lbc_lnk( zhdiv, 'T', 1. )
 
Index: /trunk/NEMO/OPA_SRC/DYN/divcur.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/divcur.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/DYN/divcur.F90	(revision 911)
@@ -14,4 +14,5 @@
    USE in_out_manager  ! I/O manager
    USE obc_oce         ! ocean lateral open boundary condition
+   USE bdy_oce	       ! Unstructured open boundaries variables
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
 
@@ -77,4 +78,5 @@
       !!   8.2  !  00-03  (G. Madec)  no slip accurate
       !!   9.0  !  03-08  (G. Madec)  merged of cur and div, free form, F90
+      !!        !  05-01  (J. Chanut, A. Sellar) unstructured open boundaries
       !!----------------------------------------------------------------------
       !! * Arguments
@@ -134,4 +136,12 @@
          ENDIF
 #endif
+#endif         
+#if defined key_bdy || key_bdy_tides
+         ! unstructured open boundaries (div must be zero behind the open boundary)
+         DO jj = 1, jpj
+           DO ji = 1, jpi
+             hdivn(ji,jj,jk)=hdivn(ji,jj,jk)*bdytmask(ji,jj)
+           END DO
+         END DO
 #endif         
 #if defined key_agrif
@@ -291,4 +301,5 @@
       !!   8.1  !  97-08  (J.M. Molines)  Open boundaries
       !!   9.0  !  02-09  (G. Madec, E. Durand)  Free form, F90
+      !!        !  05-01  (J. Chanut) Unstructured open boundaries
       !!----------------------------------------------------------------------
       !! * Arguments
@@ -344,4 +355,12 @@
 #endif
 #endif         
+#if defined key_bdy || key_bdy_tides
+         ! unstructured open boundaries (div must be zero behind the open boundary)
+         DO jj = 1, jpj
+           DO ji = 1, jpi
+             hdivn(ji,jj,jk)=hdivn(ji,jj,jk)*bdytmask(ji,jj)
+           END DO
+         END DO
+#endif        
 #if defined key_agrif
          if ( .NOT. AGRIF_Root() ) then
Index: /trunk/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 911)
@@ -16,4 +16,7 @@
    USE obcdyn_bt       ! 2D open boundary condition for momentum (obc_dyn_bt routine)
    USE obcvol          ! ocean open boundary condition (obc_vol routines)
+   USE bdy_oce         ! unstructured open boundary conditions
+   USE bdydta          ! unstructured open boundary conditions
+   USE bdydyn          ! unstructured open boundary conditions
    USE dynspg_oce      ! type of surface pressure gradient
    USE lbclnk          ! lateral boundary condition (or mpp link)
@@ -66,4 +69,5 @@
       !!        !  02-10  (C. Talandier, A-M. Treguier) Open boundary cond.
       !!   9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
+      !!    "   !  07-07  (D. Storkey) Calls to BDY routines. 
       !!----------------------------------------------------------------------
       !! * Arguments
@@ -186,4 +190,23 @@
             END DO
          END DO
+
+         IF( lk_vvl ) THEN
+            ! Unweight velocities prior to updating open boundaries.
+
+            DO jj = 1, jpj                      ! caution: don't use (:,:) for this loop
+               DO ji = 1, jpi                   ! it causes optimization problems on NEC in auto-tasking
+                  ua(ji,jj,jk) = ua(ji,jj,jk) / fse3u(ji,jj,jk)
+                  va(ji,jj,jk) = va(ji,jj,jk) / fse3v(ji,jj,jk)
+
+                  un(ji,jj,jk) = un(ji,jj,jk) / fse3u(ji,jj,jk)
+                  vn(ji,jj,jk) = vn(ji,jj,jk) / fse3v(ji,jj,jk)
+
+                  ub(ji,jj,jk) = ub(ji,jj,jk) / zfse3ub(ji,jj,jk)
+                  vb(ji,jj,jk) = vb(ji,jj,jk) / zfse3vb(ji,jj,jk)
+               END DO
+            END DO
+
+         ENDIF
+
 # if defined key_obc
          !                                             ! ===============
@@ -209,4 +232,48 @@
 
          IF ( ln_vol_cst ) CALL obc_vol( kt )
+
+      ENDIF
+
+      !                                                ! ===============
+      DO jk = 1, jpkm1                                 ! Horizontal slab
+         !                                             ! ===============
+# elif defined key_bdy || key_bdy_tides
+         !                                             ! ===============
+      END DO                                           !   End of slab
+      !                                                ! ===============
+      ! Update (ua,va) along open boundaries (for exp or ts options).
+      IF ( lk_dynspg_exp .or. lk_dynspg_ts ) THEN
+  
+         CALL bdy_dyn_frs( kt )
+
+         IF ( ln_bdy_fla ) THEN
+
+            ua_e(:,:)=0.0
+            va_e(:,:)=0.0
+
+            ! Set these variables for use in bdy_dyn_fla
+            hu_e(:,:) = hu(:,:)
+            hv_e(:,:) = hv(:,:)
+
+            DO jk = 1, jpkm1
+               !! Vertically integrated momentum trends
+               ua_e(:,:) = ua_e(:,:) + fse3u(:,:,jk) * umask(:,:,jk) * ua(:,:,jk)
+               va_e(:,:) = va_e(:,:) + fse3v(:,:,jk) * vmask(:,:,jk) * va(:,:,jk)
+            END DO
+
+            DO jk = 1 , jpkm1
+               ua(:,:,jk) = ua(:,:,jk) - ua_e(:,:) * hur(:,:)
+               va(:,:,jk) = va(:,:,jk) - va_e(:,:) * hvr(:,:)
+            END DO
+
+            CALL bdy_dta_bt( kt+1, 0)
+            CALL bdy_dyn_fla
+
+         ENDIF
+
+         DO jk = 1 , jpkm1
+            ua(:,:,jk) = ua(:,:,jk) + ua_e(:,:) * hur(:,:)
+            va(:,:,jk) = va(:,:,jk) + va_e(:,:) * hvr(:,:)
+         END DO
 
       ENDIF
Index: /trunk/NEMO/OPA_SRC/DYN/dynspg_flt.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 911)
@@ -11,4 +11,5 @@
    !!            " "  !  05-11  (V. Garnier) Surface pressure gradient organization
    !!            " "  !  06-07  (S. Masson)  distributed restart using iom
+   !!            " "  !  05-01  (J.Chanut, A.Sellar) Calls to BDY routines. 
    !!----------------------------------------------------------------------
 #if defined key_dynspg_flt   ||   defined key_esopa  
@@ -36,4 +37,7 @@
    USE obcdyn          ! ocean open boundary condition (obc_dyn routines)
    USE obcvol          ! ocean open boundary condition (obc_vol routines)
+   USE bdy_oce         ! Unstructured open boundaries condition
+   USE bdydyn          ! Unstructured open boundaries condition (bdy_dyn routine) 
+   USE bdyvol          ! Unstructured open boundaries condition (bdy_vol routine)
    USE cla_dynspg      ! cross land advection
    USE in_out_manager  ! I/O manager
@@ -249,4 +253,13 @@
       CALL obc_vol( kt )      ! Correction of the barotropic componant velocity to control the volume of the system
 #endif
+#if defined key_bdy
+      ! Update velocities on unstructured boundary using the Flow Relaxation Scheme
+      CALL bdy_dyn_frs( kt )
+
+      IF (ln_bdy_vol) THEN
+      ! Correction of the barotropic component velocity to control the volume of the system
+        CALL bdy_vol( kt )
+      ENDIF
+#endif
 #if defined key_agrif
       CALL Agrif_dyn( kt )    ! Update velocities on each coarse/fine interfaces 
@@ -377,4 +390,10 @@
             spgu(ji,jj) = z2dt * ztdgu * obcumask(ji,jj)
             spgv(ji,jj) = z2dt * ztdgv * obcvmask(ji,jj)
+#elif defined key_bdy
+            ! caution : grad D = 0 along open boundaries
+            ! Remark: The filtering force could be reduced here in the FRS zone
+            !         by multiplying spgu/spgv by (1-alpha) ??  
+            spgu(ji,jj) = z2dt * ztdgu * bdyumask(ji,jj)
+            spgv(ji,jj) = z2dt * ztdgv * bdyvmask(ji,jj)           
 #else
             spgu(ji,jj) = z2dt * ztdgu
Index: /trunk/NEMO/OPA_SRC/DYN/dynspg_oce.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/dynspg_oce.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/DYN/dynspg_oce.F90	(revision 911)
@@ -46,6 +46,7 @@
          un_b  , vn_b                     ! vertically integrated horizontal velocities (now)
       REAL(wp), PUBLIC, DIMENSION(jpi,jpj) :: & ! variables of the explicit barotropic loop
-         sshn_e, ssha_e,               &  ! sea surface heigth (now,after)
-         ua_e  , va_e                     ! vertically integrated horizontal velocities (after)
+         sshb_e, sshn_e, ssha_e,       &  ! sea surface heigth (before,now,after)
+         ua_e  , va_e,                 &  ! vertically integrated horizontal velocities (after)
+         hu_e  , hv_e                     ! depth arrays for the barotropic solution
 #endif
 
Index: /trunk/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 911)
@@ -7,5 +7,6 @@
    !!             " "  !  05-11  (V. Garnier, G. Madec)  optimization
    !!             9.0  !  06-08  (S. Masson)  distributed restart using iom
-   !!             9.0  !  08-01  (R. Benshila)  change averaging method
+   !!              "   !  08-01  (R. Benshila)  change averaging method
+   !!              "   !  07-07  (D. Storkey) calls to BDY routines
    !!---------------------------------------------------------------------
 #if defined key_dynspg_ts   ||   defined key_esopa
@@ -30,4 +31,9 @@
    USE obc_oce         ! Lateral open boundary condition
    USE obc_par         ! open boundary condition parameters
+   USE bdy_oce         ! unstructured open boundaries
+   USE bdy_par         ! unstructured open boundaries
+   USE bdydta          ! unstructured open boundaries
+   USE bdydyn          ! unstructured open boundaries
+   USE bdytides        ! tidal forcing at unstructured open boundaries.
    USE lib_mpp         ! distributed memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
@@ -102,9 +108,9 @@
          zua, zva, zub, zvb,                &  !     "        "
          zssha_b, zua_b, zva_b,             &  !     "        "
-         zsshb_e, zub_e, zvb_e,             &  !     "        "
+         zub_e, zvb_e,                      &  !     "        "
          zun_e, zvn_e                          !     "        "
       !! Variable volume
       REAL(wp), DIMENSION(jpi,jpj)     ::   &
-         zspgu_1, zspgv_1, zsshun_e, zsshvn_e, hu_e, hv_e         ! 2D workspace
+         zspgu_1, zspgv_1, zsshun_e, zsshvn_e                     ! 2D workspace
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zfse3un_e, zfse3vn_e  ! 3D workspace
       !!----------------------------------------------------------------------
@@ -130,4 +136,6 @@
          ua_e(:,:)   = un_b(:,:)
          va_e(:,:)   = vn_b(:,:)
+         hu_e(:,:)   = hu(:,:)
+         hv_e(:,:)   = hv(:,:)
 
          IF( ln_dynvor_een ) THEN
@@ -300,5 +308,5 @@
 
       ! variables for the barotropic equations
-      zsshb_e(:,:) = sshn_b(:,:)       ! (barotropic) sea surface height (before and now)
+      sshb_e (:,:) = sshn_b(:,:)       ! (barotropic) sea surface height (before and now)
       sshn_e (:,:) = sshn_b(:,:)
       zub_e  (:,:) = un_b  (:,:)       ! barotropic transports issued from the barotropic equations (before and now)
@@ -309,9 +317,9 @@
       zua_b  (:,:) = 0.e0
       zva_b  (:,:) = 0.e0
+      hu_e   (:,:) = hu   (:,:)     ! (barotropic) ocean depth at u-point
+      hv_e   (:,:) = hv   (:,:)     ! (barotropic) ocean depth at v-point
       IF( lk_vvl ) THEN
          zsshun_e(:,:)    = sshu (:,:)     ! (barotropic) sea surface height (now) at u-point
          zsshvn_e(:,:)    = sshv (:,:)     ! (barotropic) sea surface height (now) at v-point
-         hu_e(:,:)        = hu   (:,:)     ! (barotropic) ocean depth at u-point
-         hv_e(:,:)        = hv   (:,:)     ! (barotropic) ocean depth at v-point
          zfse3un_e(:,:,:) = fse3u(:,:,:)   ! (barotropic) scale factors  at u-point
          zfse3un_e(:,:,:) = fse3v(:,:,:)   ! (barotropic) scale factors  at v-point
@@ -338,7 +346,9 @@
          ! Time interpolation of open boundary condition data
          IF( lk_obc )   CALL obc_dta_bt( kt, jit )
+         IF( lk_bdy .or. lk_bdy_tides)   CALL bdy_dta_bt( kt, jit+1 )
 
          ! Horizontal divergence of barotropic transports
          !--------------------------------------------------
+         zhdiv(:,:) = 0.e0
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -360,9 +370,17 @@
 #endif
 
+         IF( lk_bdy .or. lk_bdy_tides ) THEN
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  zhdiv(ji,jj) = zhdiv(ji,jj)*bdytmask(ji,jj)
+               END DO
+            END DO
+         ENDIF
+
          ! Sea surface height from the barotropic system
          !----------------------------------------------
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               ssha_e(ji,jj) = ( zsshb_e(ji,jj) - z2dt_e *  ( zraur * emp(ji,jj)  &
+               ssha_e(ji,jj) = ( sshb_e(ji,jj) - z2dt_e *  ( zraur * emp(ji,jj)  &
             &            +  zhdiv(ji,jj) ) ) * tmask(ji,jj,1)
             END DO
@@ -457,5 +475,5 @@
          !         - Correct the barotropic transports
          IF( lk_obc )   CALL obc_fla_ts
-
+         IF( lk_bdy .or. lk_bdy_tides )   CALL bdy_dyn_fla
 
          ! ... Boundary conditions on ua_e, va_e, ssha_e
@@ -475,5 +493,5 @@
          ! ---------------------------------------
          IF( neuler == 0 .AND. jit == 1 ) THEN   ! Euler (forward) time stepping
-            zsshb_e(:,:) = sshn_e(:,:)
+            sshb_e (:,:) = sshn_e(:,:)
             zub_e  (:,:) = zun_e (:,:)
             zvb_e  (:,:) = zvn_e (:,:)
@@ -482,5 +500,5 @@
             zvn_e  (:,:) = va_e  (:,:)
          ELSE                                        ! Asselin filtering
-            zsshb_e(:,:) = atfp * ( zsshb_e(:,:) + ssha_e(:,:) ) + atfp1 * sshn_e(:,:)
+            sshb_e (:,:) = atfp * ( sshb_e(:,:) + ssha_e(:,:) ) + atfp1 * sshn_e(:,:)
             zub_e  (:,:) = atfp * ( zub_e  (:,:) + ua_e  (:,:) ) + atfp1 * zun_e  (:,:)
             zvb_e  (:,:) = atfp * ( zvb_e  (:,:) + va_e  (:,:) ) + atfp1 * zvn_e  (:,:)
@@ -571,4 +589,12 @@
       IF( lp_obc_south )   zhdiv(nis0  :nis1  ,njs0  :njs1)   = 0.e0    ! south
 #endif
+
+      IF ( lk_bdy .or. lk_bdy_tides ) THEN
+         DO jj = 1, jpj
+           DO ji = 1, jpi
+             zhdiv(ji,jj) = zhdiv(ji,jj)*bdytmask(ji,jj)
+           END DO
+         END DO
+      ENDIF
 
       ! sea surface height
Index: /trunk/NEMO/OPA_SRC/DYN/wzvmod.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/DYN/wzvmod.F90	(revision 910)
+++ /trunk/NEMO/OPA_SRC/DYN/wzvmod.F90	(revision 911)
@@ -7,4 +7,5 @@
    !!             7.0  !  96-01  (G. Madec)  Statement function for e3
    !!             8.5  !  02-07  (G. Madec)  Free form, F90
+   !!              "   !  07-07  (D. Storkey) Zero zhdiv at open boundary (BDY) 
    !!----------------------------------------------------------------------
    !!   wzv        : Compute the vertical velocity
@@ -18,4 +19,5 @@
    USE prtctl          ! Print control
    USE phycst
+   USE bdy_oce         ! unstructured open boundaries
    USE lbclnk          ! ocean lateral boundary condition (or mpp link)
 
@@ -54,4 +56,5 @@
 
       !! * Local declarations
+      INTEGER  ::     jgrd, jb           ! temporary scalars
       INTEGER  ::           jk           ! dummy loop indices
       !! Variable volume
@@ -88,4 +91,5 @@
          ! Horizontal divergence of barotropic transports
          !--------------------------------------------------
+         zhdiv(:,:) = 0.e0
          DO jj = 2, jpjm1
             DO ji = 2, jpim1   ! vector opt.
@@ -105,4 +109,15 @@
          IF( lp_obc_north )   zhdiv(nin0  :nin1  ,njn0p1:njn1p1) = 0.e0    ! north
          IF( lp_obc_south )   zhdiv(nis0  :nis1  ,njs0  :njs1)   = 0.e0    ! south
+#endif
+
+#if defined key_bdy || defined key_bdy_tides
+         jgrd=1 !: tracer grid.
+         DO jb = 1, nblenrim(jgrd)
+           ji = nbi(jb,jgrd)
+           jj = nbj(jb,jgrd)
+           zhdiv(ji, jj) = 0.e0
+           zhdiv(ji, jj) = 0.e0
+           zhdiv(ji, jj) = 0.e0
+         END DO
 #endif
 
